#ifndef	monit_h_
#define	monit_h_

#include "utype.h"

#if	_ROMADRS
//	0x0800_2000ȍ~ɔzu:application mode
#define	BOOTLOADER_MODE		0
#define	APPLICATION_MODE	1

#else
//	0x0800_0000ɔzu:bootloader firmware
#define	BOOTLOADER_MODE		1
#define	APPLICATION_MODE	0

#endif


void UserInit(void);
void ProcessIO(void);
void USBtask(void);

void mon_int_handler(void);

/********************************************************************
 *	`
 ********************************************************************
 */
#define	PACKET_SIZE		64

typedef union {
	uchar raw[PACKET_SIZE];

	struct{
		uchar  cmd;
		uchar  subcmd;
		ushort size;

		uint   adrs;
		int    data[(PACKET_SIZE/4)-2];
	};

	int rawint[PACKET_SIZE/4];

	// PICwriterp.
	struct{
		uchar  piccmd;
		uchar  picsize;
		uchar  picadrl;
		uchar  picadrh;
		uchar  picadru;
		uchar  piccmd4;
		uchar  picms;
		uchar  picdata[PACKET_SIZE - 7];
	};
} Packet;

enum {
	MEM_BYTE  = 0,
	MEM_HALF  = 1,
	MEM_WORD  = 2,
};

#ifdef	STM8S_D
//	|[go̓f[^.   		  	  JTAG  PIC   AVR
//----------------------------------------------------------
#define	PGC	 		PA14			// TCK  PGC =(AVR-SCK)
#define	PGM	 		PA15			// TDI  PGM =(AVR-MOSI)
#define	PGD	 		PB3				// TDO  PGD =(AVR-MISO)
#define	MCLR 		PA13			// TMS  MCLR=(AVR-RST)
//----------------------------------------------------------
#endif	//STM8S_D


#ifdef	STBEE_MINI
//	|[go̓f[^.    		  	  JTAG  PIC   AVR
//----------------------------------------------------------
#define	PGC	 		PB11			// TCK  PGC =(AVR-SCK)
#define	PGM	 		PB10			// TDI  PGM =(AVR-MOSI)
#define	PGD	 		PB9				// TDO  PGD =(AVR-MISO)
#define	MCLR 		PB8				// TMS  MCLR=(AVR-RST)
//----------------------------------------------------------
#endif	//STBEE_MINI

//	|[gǂݍ.
#define	inPGC	 	PGC	
#define	inPGM	 	PGM
#define	inPGD	 	PGD
#define	inMCLR 		MCLR

//	WX^ (0=o)
#define	dirPGC	 	PGC
#define	dirPGM	 	PGM
#define	dirPGD	 	PGD
#define	dirMCLR 	MCLR

void wait_us(int us);
void wait_ms(int ms);
void wait_u8s(int u8s);
void led_on(void);
void led_off(void);
void led_blink(int interval);
void usbModuleDisable(void);
void Init_Monitor(void);

#endif

